diff --git a/lib/hive/config.rb b/lib/hive/config.rb
index c686876bc..e4236e2d6 100644
--- a/lib/hive/config.rb
+++ b/lib/hive/config.rb
@@ -324,6 +324,11 @@ module Hive
         # long codex-backed scan never consumes a task-dispatch slot.
         "max_concurrent_patrol_scans" => 1,
         "transient_retry_backoff_sec" => 60,
+        # Probe-gated auto-retry of the two v1 recoverable terminal-error
+        # markers (`implementer_failed` Codex-401 + `claude_launch_failed`).
+        # `enabled` is the global kill-switch; per-reason tuning is deferred
+        # (the retry limit / backoff are hardcoded in StaleAgentHealer).
+        "auto_retry" => { "enabled" => true },
         "shutdown_grace_sec" => 600,
         # R-02: per-child wall-clock timeout for daemon-spawned `hive`
         # children. `child_timeout_sec` is the default cap (0 disables —
diff --git a/lib/hive/daemon/dispatcher.rb b/lib/hive/daemon/dispatcher.rb
index 1f272c697..dde38583e 100644
--- a/lib/hive/daemon/dispatcher.rb
+++ b/lib/hive/daemon/dispatcher.rb
@@ -12,6 +12,8 @@ require "hive/daemon/concurrency_controller"
 require "hive/daemon/child_supervisor"
 require "hive/daemon/status_consumer"
 require "hive/daemon/stale_agent_healer"
+require "hive/daemon/health_probe"
+require "hive/daemon/health_signals"
 require "hive/daemon/display_name_backfiller"
 require "hive/daemon/task_id_backfiller"
 require "hive/daemon/dispatch_request_queue"
@@ -100,11 +102,17 @@ module Hive
           "agent_marker_grace_sec",
           Hive::TaskAction::DEFAULT_AGENT_MARKER_GRACE_SEC
         )
-        @stale_agent_healer = StaleAgentHealer.new(
-          controller: @controller,
-          logger: @logger,
-          grace_sec: agent_marker_grace_sec
-        )
+        @health_probe = Hive::Daemon::HealthProbe.new(config: @config)
+        # Per-tick probe memo shared with the healer; cleared each tick so
+        # parked markers never run the same expensive probe twice per poll
+        # (mirrors @enabled_cache).
+        @signal_cache = Hive::Daemon::HealthSignalCache.new
+        # Baseline SHA-256 of the file that defines SCHEMA_VERSIONS. Captured
+        # before the healer is built so the probe-gated auto-retry can verify
+        # the loaded code matches the on-disk lib/hive.rb (the same drift
+        # signal `run_forever` uses to re-exec a stale daemon).
+        @code_fingerprint = compute_code_fingerprint
+        @stale_agent_healer = build_stale_agent_healer(agent_marker_grace_sec)
         # Additive self-heal for tasks whose one-shot name generation at
         # `hive new` never landed (agent/codex outage). Re-spawns
         # `hive generate-name <folder>` on later ticks; never touches
@@ -124,16 +132,15 @@ module Hive
         @shutdown = false
         @reload = false
         @reexec_requested = false
-        # Baseline SHA-256 of the file that defines SCHEMA_VERSIONS. The
-        # daemon is a long-running process whose in-memory constants
-        # freeze at load time, while shelled-out `hive` subprocesses load
-        # fresh code on every invocation. After a `git pull` or gem
-        # upgrade that bumps a schema, the in-process consumer rejects
-        # every envelope (e.g. 8946 `got 2, want 1` events were logged
-        # over ~3 days between 2026-05-15 PR #78 and the next restart).
-        # Capturing the source digest here lets `run_forever` detect the
-        # drift and re-exec instead of hard-failing forever.
-        @code_fingerprint = compute_code_fingerprint
+        # `@code_fingerprint` (captured above, before the healer build) is the
+        # loaded-code baseline. The daemon is a long-running process whose
+        # in-memory constants freeze at load time, while shelled-out `hive`
+        # subprocesses load fresh code on every invocation; after a `git pull`
+        # or gem upgrade that bumps a schema, the in-process consumer rejects
+        # every envelope (e.g. 8946 `got 2, want 1` events were logged over
+        # ~3 days between 2026-05-15 PR #78 and the next restart).
+        # `run_forever` compares this baseline against a fresh digest and
+        # re-execs instead of hard-failing forever.
         @last_reexec_at = nil
         @started_at = nil
         @last_tick_at = nil
@@ -189,6 +196,9 @@ module Hive
         # cache populated on first sight stuck for the daemon's
         # lifetime and the only way to honour a disable was SIGHUP.
         @enabled_cache.clear
+        # Clear the per-tick health-probe memo so probe results recompute on
+        # the next tick (mirrors the enable cache's one-poll-interval TTL).
+        @signal_cache.clear
         @logger.event(:tick_begin, now: now.utc.iso8601)
         reset_active_agent_snapshot
 
@@ -1818,15 +1828,14 @@ module Hive
             "child_kill_grace_sec", ChildSupervisor::DEFAULT_KILL_GRACE_SEC
           )
         )
-        # Rebuild the healer so an operator tuning
-        # daemon.agent_marker_grace_sec via SIGHUP takes effect within
-        # one tick. Without this rebuild the healer keeps the grace it
-        # captured at boot and only a full daemon restart applies new
-        # values.
-        @stale_agent_healer = StaleAgentHealer.new(
-          controller: @controller,
-          logger: @logger,
-          grace_sec: @daemon_cfg.fetch(
+        # Rebuild the healer (and its probe/kill-switch collaborators) so an
+        # operator tuning daemon.agent_marker_grace_sec or the auto_retry
+        # kill-switch via SIGHUP takes effect within one tick. Without this
+        # rebuild the healer keeps the values it captured at boot.
+        @health_probe = Hive::Daemon::HealthProbe.new(config: @config)
+        @signal_cache = Hive::Daemon::HealthSignalCache.new
+        @stale_agent_healer = build_stale_agent_healer(
+          @daemon_cfg.fetch(
             "agent_marker_grace_sec",
             Hive::TaskAction::DEFAULT_AGENT_MARKER_GRACE_SEC
           )
@@ -1851,6 +1860,29 @@ module Hive
                               keeping_previous: true)
       end
 
+      # Build the StaleAgentHealer with the probe-gated auto-retry seams
+      # wired: the health probe, the per-tick signal cache, the kill-switch
+      # flag, and the loaded-code fingerprint. Per-project config is NOT
+      # injected here — the healer resolves it through its own
+      # `Hive::Config.find_project` + `Config.load` fallback (the injectable
+      # `project_config_resolver` seam is exercised only by tests), which is
+      # functionally equivalent to the dispatcher's own `project_enabled?`
+      # resolution.
+      def build_stale_agent_healer(grace_sec)
+        auto_retry_enabled = @daemon_cfg.dig("auto_retry", "enabled") != false
+        StaleAgentHealer.new(
+          controller: @controller,
+          logger: @logger,
+          grace_sec: grace_sec,
+          probe: @health_probe,
+          signal_cache: @signal_cache,
+          auto_retry_enabled: auto_retry_enabled,
+          state_home: Hive::Paths.state_home,
+          env: ENV.to_h,
+          code_fingerprint: @code_fingerprint
+        )
+      end
+
       def install_signal_handlers!
         Signal.trap("TERM") { @shutdown = true }
         Signal.trap("INT")  { @shutdown = true }
diff --git a/lib/hive/daemon/health_probe.rb b/lib/hive/daemon/health_probe.rb
new file mode 100644
index 000000000..16fa1df14
--- /dev/null
+++ b/lib/hive/daemon/health_probe.rb
@@ -0,0 +1,377 @@
+require "digest"
+require "open3"
+require "stringio"
+require "timeout"
+
+require "hive/agent_profiles"
+require "hive/claude_launcher"
+require "hive/commands/doctor"
+
+module Hive
+  module Daemon
+    # Bounded, auditable answer to "is this dependency healthy right now?"
+    # for the StaleAgentHealer's probe-gated auto-retry of the two v1
+    # recoverable terminal-error markers:
+    #
+    #   - `implementer_failed` (Codex auth failure only) → `probe_codex_auth`
+    #   - `claude_launch_failed`                        → `probe_claude_launcher`
+    #
+    # plus a universal `hive doctor` / agent-health precondition that must
+    # pass before EITHER reason is cleared.
+    #
+    # Every probe returns a `Result` — it never raises. A shell-out timeout,
+    # `Errno::ENOENT`, a non-zero exit (where applicable), or any unexpected
+    # exception degrades to `healthy: false` with a structured `detail`, so a
+    # wedged probe is always fail-closed ("not healthy, do not retry").
+    #
+    # Shelling out is isolated behind an injectable `runner:` seam so unit
+    # tests never fork a real CLI. Production uses `ShellRunner`, which
+    # wraps `Open3.capture3` in a per-command `Timeout`.
+    class HealthProbe
+      # Normalized result of a single probe. `healthy` is the single boolean
+      # gate; `status` is "healthy"/"unhealthy"; `detail` is the human- and
+      # audit-log-readable reason; `stdout`/`stderr` carry captured command
+      # output (empty for in-process probes); `elapsed_sec` bounds the audit
+      # trail.
+      Result = Struct.new(
+        :name, :healthy, :status, :detail, :stdout, :stderr, :elapsed_sec,
+        keyword_init: true
+      ) do
+        def initialize(name:, healthy:, status: nil, detail: nil, stdout: "", stderr: "", elapsed_sec: 0.0)
+          super
+          self.healthy = !!healthy
+          self.status = status.nil? ? (healthy ? "healthy" : "unhealthy") : status.to_s
+          self.detail = detail.to_s
+          self.stdout = stdout.to_s
+          self.stderr = stderr.to_s
+          self.elapsed_sec = elapsed_sec.to_f
+        end
+
+        def healthy?
+          healthy
+        end
+      end
+
+      # Normalized single-command result returned by a runner.
+      CommandResult = Struct.new(:stdout, :stderr, :exitstatus, keyword_init: true) do
+        def success?
+          exitstatus == 0
+        end
+
+        def output
+          [ stdout, stderr ].map { |part| part.to_s.strip }.reject(&:empty?).join("\n")
+        end
+      end
+
+      # Production runner: Open3.capture3 under a per-command Timeout. A
+      # missing binary becomes a 127 result; a timeout becomes a 124 result —
+      # both fail-closed via `success? == false` and never raise.
+      class ShellRunner
+        def capture3(argv, env:, timeout_sec:)
+          out, err, status = Timeout.timeout(timeout_sec) do
+            Open3.capture3(env.to_h, *argv)
+          end
+          CommandResult.new(stdout: out.to_s, stderr: err.to_s, exitstatus: status.exitstatus)
+        rescue Errno::ENOENT => e
+          CommandResult.new(stdout: "", stderr: e.message, exitstatus: 127)
+        rescue Timeout::Error
+          CommandResult.new(stdout: "", stderr: "timed out after #{timeout_sec}s", exitstatus: 124)
+        end
+      end
+
+      CODEX_LOGIN_TIMEOUT_SEC = 15
+      CODEX_SMOKE_TIMEOUT_SEC = 20
+      # The in-process `hive doctor` precondition can shell out (e.g. tmux
+      # `-V` via `ClaudeLauncher.tmux_status`, qmd `--version`, skill
+      # verifications) on unbounded `Open3.capture3` calls, so it gets its
+      # own wall-clock bound in addition to the reason probes' per-command
+      # runner timeouts (R5).
+      UNIVERSAL_PROBE_TIMEOUT_SEC = 30
+      CODEX_SMOKE_PROMPT = "reply ok".freeze
+
+      # Doctor rows that mean "this dependency is unusable", shared with the
+      # universal probe's failing-row check and the stage-skill check.
+      FAILING_STATUSES = %w[missing version_too_old].freeze
+
+      attr_reader :config, :project_root
+
+      # Canonical on-disk path to the Claude interactive wrapper script. A
+      # class method so both the probe (default) and the healer (fingerprint
+      # input) read one source of truth.
+      def self.wrapper_path
+        File.expand_path("../scripts/interactive_claude_wrapper.sh", __dir__)
+      end
+
+      # `doctor_factory:` is an injectable seam for the in-process `hive
+      # doctor` precondition (defaults to `Hive::Commands::Doctor`). Tests
+      # inject a fake whose `.new(...)` returns an object responding to
+      # `#call` and `#rows`, so the universal probe never touches a real
+      # skill filesystem. `runner:` isolates shell-outs (see ShellRunner).
+      def initialize(config:, project_root: nil, runner: nil, doctor_factory: nil)
+        @config = config
+        @project_root = project_root
+        @runner = runner || ShellRunner.new
+        @doctor_factory = doctor_factory || Hive::Commands::Doctor
+      end
+
+      # Universal precondition: `hive doctor` green plus the retried stage's
+      # configured skill resolving to a present install. Healthy iff no
+      # doctor row has status `missing`/`version_too_old` AND the stage's
+      # profile skill (if any) verifies present.
+      def probe_universal(config: nil, project_root: nil, stage: nil)
+        build("universal") do
+          Timeout.timeout(UNIVERSAL_PROBE_TIMEOUT_SEC) do
+            cfg = config || @config
+            root = project_root || @project_root
+            doctor = @doctor_factory.new(
+              config: cfg, project_root: root, json: true, output: StringIO.new
+            )
+            doctor.call
+            if doctor.rows.nil?
+              next [ false, "doctor config error (no rows produced)" ]
+            end
+            failing = doctor.rows.select { |row| FAILING_STATUSES.include?(row[:status].to_s) }
+            stage_detail = stage_skill_failure(stage, cfg: cfg, project_root: root)
+            healthy = failing.empty? && stage_detail.nil?
+            detail = if healthy
+                        "doctor green (no missing/version_too_old rows)"
+            else
+                        [ failing_desc(failing), stage_detail ].compact.join("; ")
+            end
+            [ healthy, detail ]
+          end
+        end
+      end
+
+      # Codex auth probe: the in-process credential check AND `codex login
+      # status` (falling back to `codex auth status` on unknown-command
+      # shapes) AND a tiny `codex exec` smoke test must all pass.
+      def probe_codex_auth(env: nil)
+        build("codex_auth") do
+          env = (env || ENV.to_h).to_h
+          home = codex_home(env)
+          unless Hive::AgentProfiles.logged_in?(:codex, home: home)
+            next [ false, "no codex credential at ~/.codex/auth.json" ]
+          end
+
+          login = run_codex_login_status(env)
+          next [ false, login.detail ] unless login.ok
+
+          smoke = run_codex_smoke_test(env)
+          next [ false, smoke.detail ] unless smoke.ok
+
+          [ true, "codex login status + smoke test passed" ]
+        end
+      end
+
+      # Claude launcher probe: the wrapper file must exist, the tmux ready
+      # detector (tmux mode) must report `:present`, the claude binary must
+      # meet its minimum version, the loaded code must match the on-disk
+      # `lib/hive.rb`, and `hive doctor` must be green. All must pass.
+      def probe_claude_launcher(config: nil, project_root: nil, env: nil, wrapper_path: nil, code_fingerprint: nil, stage: nil, universal_result: nil)
+        build("claude_launcher") do
+          cfg = config || @config
+          env = (env || ENV.to_h).to_h
+          wrapper_path ||= default_wrapper_path
+          unless File.file?(wrapper_path)
+            next [ false, "launcher wrapper missing: #{wrapper_path}" ]
+          end
+
+          if Hive::Config.claude_mode(cfg) == :tmux
+            status, message = Hive::ClaudeLauncher.tmux_status
+            next [ false, message ] unless status == :present
+          end
+
+          version = claude_version_check(env, cfg: cfg)
+          next [ false, version.detail ] unless version.ok
+
+          fingerprint_detail = code_fingerprint_match(code_fingerprint)
+          next [ false, fingerprint_detail ] unless fingerprint_detail.nil?
+
+          # Reuse a precomputed universal result (the healer already ran it
+          # once this cycle) instead of building a second `hive doctor`.
+          universal = universal_result || probe_universal(config: cfg, project_root: project_root, stage: stage)
+          next [ false, "doctor not green: #{universal.detail}" ] unless universal.healthy?
+
+          [ true, "wrapper + ready detector + binary version + doctor all green" ]
+        end
+      end
+
+      private
+
+      # Shared result builder: measures wall-clock elapsed time, coerces the
+      # block's `[healthy, detail]` into a `Result`, and — crucially —
+      # rescues any unexpected exception into `healthy: false` so a probe bug
+      # can never crash a daemon tick.
+      def build(name)
+        start = monotonic_now
+        healthy, detail = yield
+        Result.new(
+          name: name,
+          healthy: !!healthy,
+          detail: detail.to_s,
+          elapsed_sec: monotonic_now - start
+        )
+      rescue StandardError => e
+        Result.new(
+          name: name,
+          healthy: false,
+          status: "unhealthy",
+          detail: "#{e.class}: #{e.message}",
+          elapsed_sec: monotonic_now - start
+        )
+      end
+
+      def monotonic_now
+        Process.clock_gettime(Process::CLOCK_MONOTONIC)
+      end
+
+      def codex_home(env)
+        home = env["CODEX_HOME"].to_s
+        home.empty? ? (env["HOME"] || Dir.home) : home
+      end
+
+      def codex_bin(env)
+        bin = env["HIVE_CODEX_BIN"].to_s
+        bin.empty? ? "codex" : bin
+      end
+
+      # In-process shell of the codex login status check. Returns a small
+      # `LoginStatus`-ish struct with `ok`/`detail` so the public probe reads
+      # declaratively. The unknown-command fallback is applied only when the
+      # primary subcommand's stderr looks like an unknown-command rejection —
+      # a genuine auth failure (exit non-zero for a real reason) must NOT be
+      # silently retried through `auth status`.
+      def run_codex_login_status(env)
+        primary = @runner.capture3(
+          [ codex_bin(env), "login", "status" ], env: env, timeout_sec: CODEX_LOGIN_TIMEOUT_SEC
+        )
+        if login_status_ok?(primary)
+          return ProbeStep.new(ok: true, detail: "codex login status reported logged-in")
+        end
+        return ProbeStep.new(ok: false, detail: login_failure_detail(primary)) unless unknown_command?(primary)
+
+        fallback = @runner.capture3(
+          [ codex_bin(env), "auth", "status" ], env: env, timeout_sec: CODEX_LOGIN_TIMEOUT_SEC
+        )
+        if login_status_ok?(fallback)
+          ProbeStep.new(ok: true, detail: "codex auth status reported logged-in")
+        else
+          ProbeStep.new(ok: false, detail: login_failure_detail(fallback, fallback: true))
+        end
+      end
+
+      def run_codex_smoke_test(env)
+        result = @runner.capture3(
+          [ codex_bin(env), "exec", "--dangerously-bypass-approvals-and-sandbox", CODEX_SMOKE_PROMPT ],
+          env: env, timeout_sec: CODEX_SMOKE_TIMEOUT_SEC
+        )
+        if result.success?
+          ProbeStep.new(ok: true, detail: "codex exec smoke test passed")
+        else
+          ProbeStep.new(ok: false, detail: "codex exec smoke test failed (exit #{result.exitstatus})")
+        end
+      end
+
+      # A shell-out step in a probe; `ok` is the pass/fail bit, `detail` the
+      # audit-log-able reason.
+      ProbeStep = Struct.new(:ok, :detail, keyword_init: true)
+
+      def login_status_ok?(result)
+        return false unless result.success?
+
+        text = result.output.downcase
+        text.include?("logged in") && !text.include?("not logged in")
+      end
+
+      def unknown_command?(result)
+        return false if result.success?
+
+        result.stderr.to_s.downcase.match?(/unknown|unrecognized|no such|not a recognized/i)
+      end
+
+      def login_failure_detail(result, fallback: false)
+        subcommand = fallback ? "codex auth status" : "codex login status"
+        "not logged in per #{subcommand} (exit #{result.exitstatus}): #{first_line(result.output)}"
+      end
+
+      def first_line(text)
+        text.to_s.lines.map(&:strip).find { |line| !line.empty? }.to_s
+      end
+
+      # `claude binary --version` meets the profile minimum. Delegates to the
+      # profile's own `check_version!` (which shells out and raises
+      # `Hive::AgentError` on missing/too-old/parse failure).
+      def claude_version_check(env, cfg: @config)
+        profile = Hive::AgentProfiles.lookup(:claude, cfg: cfg)
+        profile.check_version!
+        ProbeStep.new(ok: true, detail: "claude binary meets minimum version")
+      rescue Hive::AgentError => e
+        ProbeStep.new(ok: false, detail: e.message)
+      rescue StandardError => e
+        ProbeStep.new(ok: false, detail: "#{e.class}: #{e.message}")
+      end
+
+      # Compare the daemon's loaded code fingerprint against a fresh SHA-256
+      # of `lib/hive.rb`. Returns nil when they match (or when no expected
+      # fingerprint is supplied — the fresh digest merely must be computable);
+      # returns a failure detail otherwise.
+      def code_fingerprint_match(code_fingerprint)
+        fresh = fresh_code_digest
+        return "could not compute fresh lib/hive.rb digest" if fresh.nil?
+        return nil if code_fingerprint.nil? || code_fingerprint == fresh
+
+        "loaded code fingerprint does not match on-disk lib/hive.rb"
+      end
+
+      def fresh_code_digest
+        path = Hive::Schemas.method(:schema_path).source_location.first
+        ::Digest::SHA256.file(path).hexdigest
+      rescue StandardError
+        nil
+      end
+
+      def default_wrapper_path
+        self.class.wrapper_path
+      end
+
+      # Verify the stage's configured skill resolves for its agent profile.
+      # Returns nil when healthy; a human-readable failure string otherwise.
+      # `stage` may be a full stage dir or a bare stage name (e.g. `execute`);
+      # a nil/unknown stage contributes no extra check (doctor's
+      # brainstorm/plan/reviewer checks already run regardless).
+      def stage_skill_failure(stage, cfg: @config, project_root: @project_root)
+        key = stage_config_key(stage)
+        return nil if key.nil?
+
+        agent_name = (cfg.dig(key, "agent") || "claude").to_s
+        skill = Hive::Config.stage_skill(cfg, key)
+        return nil if skill.nil? || skill.to_s.empty?
+
+        profile = Hive::AgentProfiles.lookup(agent_name.to_sym)
+        invocation = profile.format_skill_invocation(skill)
+        status, message = profile.verify_skill(invocation, project_root: project_root)
+        return nil unless FAILING_STATUSES.include?(status.to_s)
+
+        "#{key} skill #{invocation} #{status}: #{message}"
+      rescue StandardError => e
+        "#{key} skill check failed: #{e.class}: #{e.message}"
+      end
+
+      def stage_config_key(stage)
+        return nil if stage.nil? || stage.to_s.empty?
+
+        # Stage dirs use hyphens (`5-open-pr`) while the config keys use
+        # underscores (`open_pr`); normalize so the skill check reads the
+        # right key instead of silently no-op'ing on `cfg.fetch("open-pr")`.
+        stage.to_s.split("-", 2).last.tr("-", "_")
+      end
+
+      def failing_desc(failing)
+        return nil if failing.empty?
+
+        "doctor failing rows: #{failing.map { |row| "#{row[:label]}=#{row[:status]}" }.join(', ')}"
+      end
+    end
+  end
+end
diff --git a/lib/hive/daemon/health_signals.rb b/lib/hive/daemon/health_signals.rb
new file mode 100644
index 000000000..df3d6d7f7
--- /dev/null
+++ b/lib/hive/daemon/health_signals.rb
@@ -0,0 +1,173 @@
+require "digest"
+require "hive/agent_profiles"
+
+module Hive
+  module Daemon
+    # Cheap, stable "health signal" fingerprint for the probe-gated auto-retry
+    # reasons, plus a per-tick memo cache so N parked rows sharing a
+    # reason/project run at most one probe per daemon tick.
+    #
+    # The fingerprint is deliberately TIME-INDEPENDENT: it changes only when
+    # an input that could plausibly fix the failure changes (binary path /
+    # code digest, config slice, relevant env, Codex login state, wrapper
+    # mtime+size, plugin/skill inventory, agent profile). A time-varying
+    # digest would defeat the changed-signal throttle that keeps the daemon
+    # from re-probing an expensive CLI on every 30s tick.
+    module HealthSignals
+      SKILL_INVENTORY_CAP = 100
+      ENV_KEYS = %w[HIVE_CODEX_BIN HIVE_CLAUDE_BIN HIVE_TMUX_BIN CODEX_HOME HIVE_QMD_BIN].freeze
+      STAGE_KEYS = %w[brainstorm plan execute open_pr artifacts finalize].freeze
+
+      module_function
+
+      # Canonical SHA-256 over the health-relevant inputs. Any component that
+      # fails to read degrades to a constant token (`nil` is dropped), so a
+      # transient read error cannot make the fingerprint flap.
+      def fingerprint(cfg:, project_root:, profile:, wrapper_path:, env:)
+        parts = [
+          code_digest,
+          config_slice(cfg),
+          env_slice(env),
+          codex_login_state(env),
+          wrapper_state(wrapper_path),
+          skill_inventory(project_root, env: env),
+          profile_state(profile)
+        ]
+        ::Digest::SHA256.hexdigest(parts.compact.join("\u0000"))
+      end
+
+      # SHA-256 of lib/hive.rb (the file holding SCHEMA_VERSIONS) — the same
+      # source the dispatcher uses for its re-exec drift signal. nil on any
+      # read failure (a nil component is dropped, not hashed).
+      def code_digest
+        path = Hive::Schemas.method(:schema_path).source_location.first
+        ::Digest::SHA256.file(path).hexdigest
+      rescue StandardError
+        nil
+      end
+
+      # The merged `daemon` block plus the stage agent/skill keys the retried
+      # stage (or its siblings) actually consume.
+      def config_slice(cfg)
+        daemon = cfg["daemon"] || {}
+        stages = STAGE_KEYS.flat_map do |stage|
+          slice = cfg[stage]
+          slice.nil? ? [] : [ stage, slice["agent"], slice["skill"], slice["skill_by_agent"] ]
+        end
+        canonical([ daemon, stages ])
+      end
+
+      def env_slice(env)
+        canonical(ENV_KEYS.to_h { |key| [ key, env[key] ] })
+      end
+
+      def codex_login_state(env)
+        home = env["CODEX_HOME"].to_s
+        home = env["HOME"] || Dir.home if home.empty?
+        Hive::AgentProfiles.logged_in?(:codex, home: home) ? "logged-in" : "logged-out"
+      end
+
+      # mtime + size token for the launcher wrapper; "missing" when absent.
+      def wrapper_state(wrapper_path)
+        stat = File.stat(wrapper_path)
+        "#{stat.mtime.to_i}:#{stat.size}"
+      rescue SystemCallError
+        "missing"
+      end
+
+      # Bounded `Dir[]` listing of the installed skill markers under the
+      # configured skill roots (project-local first, then user-global).
+      def skill_inventory(project_root, env:)
+        home = env["HOME"].to_s
+        home = Dir.home if home.empty?
+        roots = []
+        unless project_root.nil? || project_root.to_s.empty?
+          roots << File.join(project_root.to_s, ".claude", "skills")
+          roots << File.join(project_root.to_s, ".codex", "skills")
+        end
+        roots << File.join(home, ".claude", "skills")
+        roots << File.join(home, ".codex", "skills")
+        roots.flat_map { |root| skill_entries(root) }.join(",")
+      end
+
+      def profile_state(profile)
+        return nil if profile.nil?
+
+        "#{profile.name}:#{profile.bin}"
+      end
+
+      # Recursive, key-sorted, deterministic serialization so equal inputs
+      # (independent of hash insertion order) produce equal tokens.
+      def canonical(value)
+        case value
+        when Hash
+          value.keys.sort.map { |key| "#{key}=#{canonical(value[key])}" }.join(",")
+        when Array
+          value.map { |entry| canonical(entry) }.join("|")
+        when nil
+          ""
+        else
+          value.to_s
+        end
+      end
+
+      def skill_entries(root)
+        Dir[File.join(root, "**", "SKILL.md")]
+          .sort
+          .first(SKILL_INVENTORY_CAP)
+          .map { |path| "#{File.basename(File.dirname(path))}=#{stat_token(path)}" }
+      end
+
+      def stat_token(path)
+        stat = File.stat(path)
+        "#{stat.mtime.to_i}:#{stat.size}"
+      rescue SystemCallError
+        "?"
+      end
+    end
+
+    # Per-tick probe-result memo. Keyed by `(reason, project)`; cleared at
+    # the start of each daemon tick (mirroring Dispatcher's `@enabled_cache`)
+    # so two parked rows sharing a reason/project within one tick share one
+    # probe result, while the next tick recomputes.
+    class HealthSignalCache
+      def initialize
+        @entries = {}
+        @fingerprints = {}
+      end
+
+      def clear
+        @entries.clear
+        @fingerprints.clear
+      end
+
+      def fetch(key)
+        @entries[key]
+      end
+
+      def store(key, fingerprint:, results:)
+        @entries[key] = { fingerprint: fingerprint, results: results }
+      end
+
+      # Memoize an expensive fingerprint computation per (reason, project)
+      # per tick. The block runs at most once per key per tick; the value is
+      # dropped on `clear` so the next tick recomputes (and can detect a
+      # changed signal). This is what makes the plan's "cheap, cached"
+      # fingerprint intent actually cheap: N parked rows sharing a
+      # reason/project no longer repeat the SHA-256 + skill-inventory globs.
+      def fingerprint(key)
+        return @fingerprints[key] if @fingerprints.key?(key)
+
+        @fingerprints[key] = yield
+      end
+
+      # True when there is no recorded entry for `key` OR the recorded
+      # fingerprint differs from the freshly computed one. This is the
+      # healer's "should I re-probe?" gate.
+      def changed_since_last?(key, fingerprint)
+        entry = @entries[key]
+        entry.nil? || entry[:fingerprint] != fingerprint
+      end
+    end
+  end
+end
diff --git a/lib/hive/daemon/logger.rb b/lib/hive/daemon/logger.rb
index 6af59dc93..a7c17bfca 100644
--- a/lib/hive/daemon/logger.rb
+++ b/lib/hive/daemon/logger.rb
@@ -50,6 +50,7 @@ module Hive
         marker_heal_failed
         marker_heal_exhausted
         marker_heal_observer_missing
+        auto_retry_blocked
         display_name_backfill
         update_available
         update_check_no_result
